<?php
/**
* Filehandling class
*
* This Class is needen for the entire filehandling   
*/



/**
* Filehandling class
*
* This Class is needen for the entire filehandling
* @name file
* @version 1.0
* @author Gianni Carafa
*/
class file 
{
	/**
	* @var string contains the content of the configfile 
	*/
	var $content = "";
	
	/**
	* @var array contains the parsed content of the configfile 
	*/
	var $data_arr = array();
	
	/**
	* @var string contains the modified content of the configfile
	*/
	var $new_content = "";
	
	/**
	* @var string contains the modified header of the configfile
	*/
	var $new_header = "";
	
	/**
	* @var array the new array's which should be written into the new file
	*/
	var $new_data_arr = array();

	/**
	* reads the configfile 
	*
	* is needed to open the configfiles an read the content in it 
	* @access private
	* @return string content
	* @param string $filename
	* @global array $conf
	*/
	function read($filename){
	global $conf;
		
		$file = fopen ($conf[path][confroot].$filename, "r");
		$this->content = fread ($file, filesize ($conf[path][confroot].$filename));
		fclose ($file);
		
		return $this->content;
	}
	
	/**
	* Parses the configfile 
	*
	* is needed to parse the previously opened configfile 
	* @access private
	* @return array data_arr
	*/
	function parse(){
		
		
		preg_match_all ('/#<node>(.*)<\/node>/i', $this->content, $nodes_arr_ser, PREG_SET_ORDER);

		for($x=0; $x<count($nodes_arr_ser);$x++){
			$this->data_arr[] =  unserialize($nodes_arr_ser[$x][1]);
		}
		
		return $this->data_arr;

	} 
	
	/**
	* Loads the data 
	*
	* @access public
	* @return array data_arr
	* @uses subclass::$read
	* @uses subclass::$parse
	* @param string $filename
	* 
	* <code>
	* //example with contacts.cfg
	* $contacts_file = new file;
	* $contacts_arr = $contacts_file->getdata("contacts.cfg");
	* </code>
	*/
	function getdata($filename){
	
		$this->read($filename); 
		$this->parse(); 
	
	return $this->data_arr;
	}

	/**
	* writes the configfile 
	*
	* is needed to write the configfiles 
	* @access private
	* @param string $filename
	* @global array $conf
	*/
	function write($filename){
	global $conf;
	
		$file = fopen ($conf[path][confroot].$filename, "w");
		fwrite ($file, $this->new_content);
		fclose ($file);
	}

	/**
	* Formats the contained data 
	*
	* is needed to format the content which should be written 
	* @access private
	* @return string $new_content
	*/
	function format(){
		$new_data_arr = $this->new_data_arr;
		/*
		for($x=1; $x<count($new_data_arr); $x++){
			
			
			foreach($new_data_arr[$x][data] AS $key => $value){
				if ($value!=''){
					$new_data_arr[$x][data][$key] = stripcslashes($value);
				}else{
					unset($new_data_arr[$x][data][$key]);
				}
			}
			//html_print_r($new_data_arr[$x]);
			
            
			$this->new_content .= "#<node>".serialize($new_data_arr[$x])."</node>\n";
		}
        */
		
		foreach($new_data_arr AS $node){
			
			
			foreach($new_data_arr[$x][data] AS $key => $value){
				if ($value!=''){
					$new_data_arr[$x][data][$key] = stripcslashes($value);
				}else{
					unset($new_data_arr[$x][data][$key]);
				}
			}
			//html_print_r($new_data_arr[$x]);
			
            
			$this->new_content .= "#<node>".serialize($node)."</node>\n";
		}
        
	return $this->new_content;
	}

	/**
	* Creates a header 
	*
	* is needed to format the content which should be written 
	* @access private
	* @return string $new_content
	*/
    /*
	function makeheader(){
		$user = $_SERVER['PHP_AUTH_USER'];
		$new_header_arr = array(
			'user'=>$user,
			'modified'=>time(),
			//''=>'',
		);
		
		$this->new_header .= "#<node>".serialize($new_header_arr)."</node>\n\n\n\n";
		
	return $this->new_header;
	}
    */
    
    
	/**
	* writes the data 
	*
	* is needed to write the configfiles 
	* @access public
	* @uses subclass::format
	* @uses subclass::write
	* @param string $filename
	* @param string $confheader
	* @param array $new_data_arr
	* @return string $new_content
	*
	* <code>
	* //example with contacts.cfg
	* $contacts_file = new file;
	* $contacts_arr = $contacts_file->getdata("contacts.cfg");
	* $contacts_arr[] = $array_to_add;
	* $contacts_conf = $contacts_file->writedata("contacts.cfg", $confheader[contants.cfg], $contacts_arr);
	* </code>
	*/	
	function writedata($filename, $confheader, $new_data_arr){
		
		$this->new_content = $confheader;
		/*
		$this->makeheader();
		$this->new_content .= $this->new_header;
		*/
		$this->new_data_arr = $new_data_arr;
		
		$this->format();
		$this->write($filename);
	
	return $this->new_content;
	}

}
?>